#include <mutex>
#include <iostream>
#include <condition_variable>

using namespace std;

class bridge {
  public:
    void arrive_north();
    void leave_north();
    void arrive_south();
    void leave_south();

  private:
    int north_waiting = 0;
    int north_crossing = 0;
    int north_consecutive = 0;
    int south_waiting = 0;
    int south_crossing = 0;
    int south_consecutive = 0;

    mutex lock;
    condition_variable_any northbound_done;
    condition_variable_any southbound_done;
};

void bridge::arrive_north() {
  lock_guard<mutex> lg(lock);
  north_waiting++;
  while ((south_crossing > 0) ||
         ((south_waiting > 0) && (north_consecutive >= 5)))
  { 
    southbound_done.wait(lock);
  }
  north_waiting--;
  north_crossing++;
  north_consecutive++;
  south_consecutive = 0;
}

void bridge::leave_north() {
  lock_guard<mutex> lg(lock);
  north_crossing--;
  if (north_crossing == 0) {
    northbound_done.notify_all(); 
  }
}

void bridge::arrive_south() {
  /* reverse above */
}

void bridge::leave_south() {
  /* reverse above */
}

int main()
{
    std::cout << "Your bridge compiled!" << std::endl;
}
